package lib;

using tink.CoreApi;

class SinglePromise<T> {
	private var inProgress:Bool = false;
	private var interalPromise:Promise<T> = null;
	private var interalResolve:T->Void = null;
	private var interalReject:(Error->Void) = null;
	private final activate:Void->Void;

	public function new(activate:Void->Void) {
		this.activate = activate;
	}

	public function request():Promise<T> {
		if (this.inProgress) {
			return this.interalPromise;
		}

		this.inProgress = true;

		this.interalPromise = new Promise((resolve, reject) -> {
			this.interalResolve = resolve;
			this.interalReject = reject;

			this.activate();

			return null;
		});

		return this.interalPromise;
	}

	public function resolve(val:T) {
		if (this.inProgress) {
			this.interalResolve(val);
			this.inProgress = false;
		}
	}

	public function reject(err:Error) {
		if (this.inProgress) {
			this.interalReject(err);
			this.inProgress = false;
		}
	}
}
